import { TestBed } from '@angular/core/testing';
import { HttpClientTestingModule, HttpTestingController } from '@angular/common/http/testing';

import { FlickrService } from './flickr.service';

describe('FlickrService', () => {
  let service: FlickrService;
  let httpMock: HttpTestingController;
  beforeEach(() => {
    TestBed.configureTestingModule({
      imports: [
        HttpClientTestingModule
      ],
      providers: [FlickrService]
    });
    service = TestBed.get(FlickrService);
    httpMock = TestBed.get(HttpTestingController);
  });

  afterEach(() => {
    httpMock.verify();
  });

  it('should be created', () => {
    service = TestBed.get(FlickrService);
    expect(service).toBeTruthy();
  });

  it('it should search photos from tags', () => {
    const dummyResp = {
      "photos": {
        "page": 1,
        "pages": 1,
        "perpage": 10,
        "total": "7",
        "photo": [
          {
            "id": "31901297097",
            "owner": "62694448@N07",
            "secret": "fef5b18479",
            "server": "4817",
            "farm": 5,
            "title": "Sweet Grace",
            "ispublic": 1,
            "isfriend": 0,
            "isfamily": 0,
            "dateupload": "1548190282",
            "ownername": "PawsforLifeRescue",
            "tags": "",
            "media": "video",
            "media_status": "ready",
            "url_sq": "https://farm5.staticflickr.com/4817/31901297097_fef5b18479_s.jpg",
            "height_sq": 75,
            "width_sq": 75,
            "url_t": "https://farm5.staticflickr.com/4817/31901297097_fef5b18479_t.jpg",
            "height_t": "56",
            "width_t": "100",
            "url_s": "https://farm5.staticflickr.com/4817/31901297097_fef5b18479_m.jpg",
            "height_s": "135",
            "width_s": "240",
            "url_q": "https://farm5.staticflickr.com/4817/31901297097_fef5b18479_q.jpg",
            "height_q": "150",
            "width_q": "150",
            "url_m": "https://farm5.staticflickr.com/4817/31901297097_fef5b18479.jpg",
            "height_m": "281",
            "width_m": "500",
            "url_n": "https://farm5.staticflickr.com/4817/31901297097_fef5b18479_n.jpg",
            "height_n": 180,
            "width_n": "320",
            "url_z": "https://farm5.staticflickr.com/4817/31901297097_fef5b18479_z.jpg",
            "height_z": 360,
            "width_z": "640",
            "url_c": "https://farm5.staticflickr.com/4817/31901297097_fef5b18479_c.jpg",
            "height_c": 450,
            "width_c": "800",
            "url_l": "https://farm5.staticflickr.com/4817/31901297097_fef5b18479_b.jpg",
            "height_l": "576",
            "width_l": "1024",
            "url_o": "https://farm5.staticflickr.com/4817/31901297097_5d57aa14b7_o.jpg",
            "height_o": "720",
            "width_o": "1280"
          },
          {
            "id": "45928176535",
            "owner": "62694448@N07",
            "secret": "973f0a603b",
            "server": "7913",
            "farm": 8,
            "title": "Sweet Grace",
            "ispublic": 1,
            "isfriend": 0,
            "isfamily": 0,
            "dateupload": "1548190282",
            "ownername": "PawsforLifeRescue",
            "tags": "",
            "media": "video",
            "media_status": "ready",
            "url_sq": "https://farm8.staticflickr.com/7913/45928176535_973f0a603b_s.jpg",
            "height_sq": 75,
            "width_sq": 75,
            "url_t": "https://farm8.staticflickr.com/7913/45928176535_973f0a603b_t.jpg",
            "height_t": "100",
            "width_t": "56",
            "url_s": "https://farm8.staticflickr.com/7913/45928176535_973f0a603b_m.jpg",
            "height_s": "240",
            "width_s": "135",
            "url_q": "https://farm8.staticflickr.com/7913/45928176535_973f0a603b_q.jpg",
            "height_q": "150",
            "width_q": "150",
            "url_m": "https://farm8.staticflickr.com/7913/45928176535_973f0a603b.jpg",
            "height_m": "500",
            "width_m": "281",
            "url_n": "https://farm8.staticflickr.com/7913/45928176535_973f0a603b_n.jpg",
            "height_n": "320",
            "width_n": 180,
            "url_z": "https://farm8.staticflickr.com/7913/45928176535_973f0a603b_z.jpg",
            "height_z": "640",
            "width_z": 360,
            "url_c": "https://farm8.staticflickr.com/7913/45928176535_973f0a603b_c.jpg",
            "height_c": "800",
            "width_c": 450,
            "url_l": "https://farm8.staticflickr.com/7913/45928176535_973f0a603b_b.jpg",
            "height_l": "1024",
            "width_l": "576",
            "url_o": "https://farm8.staticflickr.com/7913/45928176535_cfce0d63c4_o.jpg",
            "height_o": "1280",
            "width_o": "720"
          },
          {
            "id": "46842556891",
            "owner": "62694448@N07",
            "secret": "ca2400e5e7",
            "server": "4902",
            "farm": 5,
            "title": "Sweet Grace",
            "ispublic": 1,
            "isfriend": 0,
            "isfamily": 0,
            "dateupload": "1548189848",
            "ownername": "PawsforLifeRescue",
            "tags": "",
            "media": "photo",
            "media_status": "ready",
            "url_sq": "https://farm5.staticflickr.com/4902/46842556891_ca2400e5e7_s.jpg",
            "height_sq": 75,
            "width_sq": 75,
            "url_t": "https://farm5.staticflickr.com/4902/46842556891_ca2400e5e7_t.jpg",
            "height_t": "75",
            "width_t": "100",
            "url_s": "https://farm5.staticflickr.com/4902/46842556891_ca2400e5e7_m.jpg",
            "height_s": "180",
            "width_s": "240",
            "url_q": "https://farm5.staticflickr.com/4902/46842556891_ca2400e5e7_q.jpg",
            "height_q": "150",
            "width_q": "150",
            "url_m": "https://farm5.staticflickr.com/4902/46842556891_ca2400e5e7.jpg",
            "height_m": "375",
            "width_m": "500",
            "url_n": "https://farm5.staticflickr.com/4902/46842556891_ca2400e5e7_n.jpg",
            "height_n": 240,
            "width_n": "320",
            "url_z": "https://farm5.staticflickr.com/4902/46842556891_ca2400e5e7_z.jpg",
            "height_z": "480",
            "width_z": "640",
            "url_c": "https://farm5.staticflickr.com/4902/46842556891_ca2400e5e7_c.jpg",
            "height_c": 600,
            "width_c": "800",
            "url_l": "https://farm5.staticflickr.com/4902/46842556891_ca2400e5e7_b.jpg",
            "height_l": "768",
            "width_l": "1024",
            "url_o": "https://farm5.staticflickr.com/4902/46842556891_5752d9955f_o.jpg",
            "height_o": "3024",
            "width_o": "4032"
          },
          {
            "id": "46842556821",
            "owner": "62694448@N07",
            "secret": "395d962a97",
            "server": "4858",
            "farm": 5,
            "title": "Sweet Grace",
            "ispublic": 1,
            "isfriend": 0,
            "isfamily": 0,
            "dateupload": "1548189850",
            "ownername": "PawsforLifeRescue",
            "tags": "",
            "media": "photo",
            "media_status": "ready",
            "url_sq": "https://farm5.staticflickr.com/4858/46842556821_395d962a97_s.jpg",
            "height_sq": 75,
            "width_sq": 75,
            "url_t": "https://farm5.staticflickr.com/4858/46842556821_395d962a97_t.jpg",
            "height_t": "100",
            "width_t": "75",
            "url_s": "https://farm5.staticflickr.com/4858/46842556821_395d962a97_m.jpg",
            "height_s": "240",
            "width_s": "180",
            "url_q": "https://farm5.staticflickr.com/4858/46842556821_395d962a97_q.jpg",
            "height_q": "150",
            "width_q": "150",
            "url_m": "https://farm5.staticflickr.com/4858/46842556821_395d962a97.jpg",
            "height_m": "500",
            "width_m": "375",
            "url_n": "https://farm5.staticflickr.com/4858/46842556821_395d962a97_n.jpg",
            "height_n": "320",
            "width_n": 240,
            "url_z": "https://farm5.staticflickr.com/4858/46842556821_395d962a97_z.jpg",
            "height_z": "640",
            "width_z": "480",
            "url_c": "https://farm5.staticflickr.com/4858/46842556821_395d962a97_c.jpg",
            "height_c": "800",
            "width_c": 600,
            "url_l": "https://farm5.staticflickr.com/4858/46842556821_395d962a97_b.jpg",
            "height_l": "1024",
            "width_l": "768",
            "url_o": "https://farm5.staticflickr.com/4858/46842556821_f81ed8858e_o.jpg",
            "height_o": "4032",
            "width_o": "3024"
          },
          {
            "id": "39877481133",
            "owner": "62694448@N07",
            "secret": "d67ba41bf1",
            "server": "7874",
            "farm": 8,
            "title": "Sweet Grace",
            "ispublic": 1,
            "isfriend": 0,
            "isfamily": 0,
            "dateupload": "1548189849",
            "ownername": "PawsforLifeRescue",
            "tags": "",
            "media": "photo",
            "media_status": "ready",
            "url_sq": "https://farm8.staticflickr.com/7874/39877481133_d67ba41bf1_s.jpg",
            "height_sq": 75,
            "width_sq": 75,
            "url_t": "https://farm8.staticflickr.com/7874/39877481133_d67ba41bf1_t.jpg",
            "height_t": "75",
            "width_t": "100",
            "url_s": "https://farm8.staticflickr.com/7874/39877481133_d67ba41bf1_m.jpg",
            "height_s": "180",
            "width_s": "240",
            "url_q": "https://farm8.staticflickr.com/7874/39877481133_d67ba41bf1_q.jpg",
            "height_q": "150",
            "width_q": "150",
            "url_m": "https://farm8.staticflickr.com/7874/39877481133_d67ba41bf1.jpg",
            "height_m": "375",
            "width_m": "500",
            "url_n": "https://farm8.staticflickr.com/7874/39877481133_d67ba41bf1_n.jpg",
            "height_n": 240,
            "width_n": "320",
            "url_z": "https://farm8.staticflickr.com/7874/39877481133_d67ba41bf1_z.jpg",
            "height_z": "480",
            "width_z": "640",
            "url_c": "https://farm8.staticflickr.com/7874/39877481133_d67ba41bf1_c.jpg",
            "height_c": 600,
            "width_c": "800",
            "url_l": "https://farm8.staticflickr.com/7874/39877481133_d67ba41bf1_b.jpg",
            "height_l": "768",
            "width_l": "1024",
            "url_o": "https://farm8.staticflickr.com/7874/39877481133_8dcb477b62_o.jpg",
            "height_o": "3024",
            "width_o": "4032"
          },
          {
            "id": "32866408248",
            "owner": "62694448@N07",
            "secret": "bf23657f0e",
            "server": "7886",
            "farm": 8,
            "title": "Sasha aka Toothless",
            "ispublic": 1,
            "isfriend": 0,
            "isfamily": 0,
            "dateupload": "1547485647",
            "ownername": "PawsforLifeRescue",
            "tags": "",
            "media": "photo",
            "media_status": "ready",
            "url_sq": "https://farm8.staticflickr.com/7886/32866408248_bf23657f0e_s.jpg",
            "height_sq": 75,
            "width_sq": 75,
            "url_t": "https://farm8.staticflickr.com/7886/32866408248_bf23657f0e_t.jpg",
            "height_t": "72",
            "width_t": "100",
            "url_s": "https://farm8.staticflickr.com/7886/32866408248_bf23657f0e_m.jpg",
            "height_s": "172",
            "width_s": "240",
            "url_q": "https://farm8.staticflickr.com/7886/32866408248_bf23657f0e_q.jpg",
            "height_q": "150",
            "width_q": "150",
            "url_m": "https://farm8.staticflickr.com/7886/32866408248_bf23657f0e.jpg",
            "height_m": "359",
            "width_m": "500",
            "url_n": "https://farm8.staticflickr.com/7886/32866408248_bf23657f0e_n.jpg",
            "height_n": 230,
            "width_n": "320",
            "url_z": "https://farm8.staticflickr.com/7886/32866408248_bf23657f0e_z.jpg",
            "height_z": "460",
            "width_z": "640",
            "url_c": "https://farm8.staticflickr.com/7886/32866408248_bf23657f0e_c.jpg",
            "height_c": 575,
            "width_c": "800",
            "url_l": "https://farm8.staticflickr.com/7886/32866408248_bf23657f0e_b.jpg",
            "height_l": "643",
            "width_l": "895",
            "url_o": "https://farm8.staticflickr.com/7886/32866408248_7a1237c360_o.jpg",
            "height_o": "643",
            "width_o": "895"
          },
          {
            "id": "45594498435",
            "owner": "65255005@N05",
            "secret": "033d39befc",
            "server": "7891",
            "farm": 8,
            "title": "Trooper getting into the spirit of things on Christmas morning 2018",
            "ispublic": 1,
            "isfriend": 0,
            "isfamily": 0,
            "dateupload": "1546054051",
            "ownername": "christineNZ2017",
            "tags": "littletrooper trooper cat feline furbaby gato cats animal mammal neko kattekop katt fur kitty katze katzen chat gatto kissa kot pisica moggy meow purr ginger tabby gingertabby baby mybaby christmas 2018 christmas2018 25thdecember",
            "media": "photo",
            "media_status": "ready",
            "url_sq": "https://farm8.staticflickr.com/7891/45594498435_033d39befc_s.jpg",
            "height_sq": 75,
            "width_sq": 75,
            "url_t": "https://farm8.staticflickr.com/7891/45594498435_033d39befc_t.jpg",
            "height_t": "67",
            "width_t": "100",
            "url_s": "https://farm8.staticflickr.com/7891/45594498435_033d39befc_m.jpg",
            "height_s": "160",
            "width_s": "240",
            "url_q": "https://farm8.staticflickr.com/7891/45594498435_033d39befc_q.jpg",
            "height_q": "150",
            "width_q": "150",
            "url_m": "https://farm8.staticflickr.com/7891/45594498435_033d39befc.jpg",
            "height_m": "333",
            "width_m": "500",
            "url_n": "https://farm8.staticflickr.com/7891/45594498435_033d39befc_n.jpg",
            "height_n": 213,
            "width_n": "320",
            "url_z": "https://farm8.staticflickr.com/7891/45594498435_033d39befc_z.jpg",
            "height_z": "427",
            "width_z": "640",
            "url_c": "https://farm8.staticflickr.com/7891/45594498435_033d39befc_c.jpg",
            "height_c": 534,
            "width_c": "800",
            "url_l": "https://farm8.staticflickr.com/7891/45594498435_033d39befc_b.jpg",
            "height_l": "683",
            "width_l": "1024"
          }
        ]
      },
      "stat": "ok"
    };

    const txtTags = "cat+purr";
    service.searchPhotos(txtTags).subscribe( (data: any) => {
      expect(data.photos.photo.length).toBe(7);
      expect(data).toEqual(dummyResp);
    });
    const request = httpMock.expectOne(service.getUrl());
    expect(request.request.method).toBe('POST');

    request.flush(dummyResp);
  });
});
